package com.fp.persistence.parmas.eval;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMDETALLEPREGUNTAS*/
@Entity(name="TarmDetallePreguntas")
@Table(name="TARMDETALLEPREGUNTAS")
public class TarmDetallePreguntas extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmDetallePreguntas
*/
@Id
@Column(name="CDETALLEPREGUNTAS" ,nullable=false, updatable=false)
private String pk;
@Column(name="CEVALUACION", nullable=true)

/**
* Referencia a la Evaluacion
*/
private String cevaluacion;

@Column(name="CRESPUESTACORRECTA", nullable=true)

/**
* Referencia a la respuesta correcta de una pregunta

*/
private Integer crespuestacorrecta;

@Column(name="CPREGUNTA", nullable=true)

/**
* Referencia a la Pregunta

*/
private Integer cpregunta;

@Column(name="CRESPUESTAINGRESADA", nullable=true)

/**
* Referencia a la Respuesta Ingresada por el usuario

*/
private Integer crespuestaingresada;

/**Contructor por defecto*/
public TarmDetallePreguntas(){
}
/**Contructor de TarmDetallePreguntas
@param pPk Clave Primaria del entity
*/
public TarmDetallePreguntas(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmDetallePreguntas
*/
public static TarmDetallePreguntas find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmDetallePreguntas obj = pEntityManager.find(TarmDetallePreguntas.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmDetallePreguntas
@return El objeto que referencia a la Clave primaria de TarmDetallePreguntas
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmDetallePreguntas
@param pPk El objeto que referencia a la nueva Clave primaria de TarmDetallePreguntas
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de cevaluacion
@return valor de cevaluacion*/
public String getCevaluacion(){
  return cevaluacion;
}
/**Fija el valor de cevaluacion
@param pCevaluacion nuevo Valor de cevaluacion*/
public void setCevaluacion(String pCevaluacion){
  cevaluacion=pCevaluacion;
}

/**Obtiene el valor de crespuestacorrecta
@return valor de crespuestacorrecta*/
public Integer getCrespuestacorrecta(){
  return crespuestacorrecta;
}
/**Fija el valor de crespuestacorrecta
@param pCrespuestacorrecta nuevo Valor de crespuestacorrecta*/
public void setCrespuestacorrecta(Integer pCrespuestacorrecta){
  crespuestacorrecta=pCrespuestacorrecta;
}

/**Obtiene el valor de cpregunta
@return valor de cpregunta*/
public Integer getCpregunta(){
  return cpregunta;
}
/**Fija el valor de cpregunta
@param pCpregunta nuevo Valor de cpregunta*/
public void setCpregunta(Integer pCpregunta){
  cpregunta=pCpregunta;
}

/**Obtiene el valor de crespuestaingresada
@return valor de crespuestaingresada*/
public Integer getCrespuestaingresada(){
  return crespuestaingresada;
}
/**Fija el valor de crespuestaingresada
@param pCrespuestaingresada nuevo Valor de crespuestaingresada*/
public void setCrespuestaingresada(Integer pCrespuestaingresada){
  crespuestaingresada=pCrespuestaingresada;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmDetallePreguntas))return false;
    TarmDetallePreguntas that = (TarmDetallePreguntas) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmDetallePreguntas
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmDetallePreguntas
*/
public Object createInstance(){
 TarmDetallePreguntas instance=new TarmDetallePreguntas();	
 return instance;
}
/**Clona la entidad TarmDetallePreguntas
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmDetallePreguntas p=(TarmDetallePreguntas)this.clone();
  return p;
}
}
